# -*- coding: utf-8 -*-
import xbmc, xbmcgui, xbmcplugin
import sys, json, re
try:
    from urllib2 import urlopen
except ImportError:
    from urllib.request import urlopen
try:
    from urllib import urlencode
except ImportError:
    from urllib.parse import urlencode
try:
    from urlparse import urlparse, parse_qs
except ImportError:
    from urllib.parse import urlparse, parse_qs
import localau


def resp(ret, recur=False):
    if 'code' in ret:
        if 'error' in ret:
            return xbmcgui.Dialog().ok('Error: ' + ret['code'], ret['error'])
        return xbmcgui.Dialog().ok('Error', ret['code'])
    if isinstance(ret, list):
        xbmcplugin.setContent(handle, 'videos')
        for elem in ret:
            resp(elem, True)
        return xbmcplugin.endOfDirectory(handle)
    assert isinstance(ret, dict)
    if 'title' not in ret:
        for k, v in ret.items():
            if isinstance(v, list):
                ret = {'title': k, 'json': json.dumps(v)}
            else:
                ret = {'title': k, 'url': v}
    li = xbmcgui.ListItem(ret['title'])
    if 'img' in ret:
        li.setArt({'thumb': ret['img']})
    if 'plot' in ret:
        li.setInfo('video', {'plot': ret['plot']})
    t = True
    if 'url' in ret:
        if isinstance(ret['url'], list):
            ret['url'] = 'stack://' + ' , '.join(ret['url'])
            if 'header' in ret:
                ret['url'] += '|' + urlencode(ret['header'])
            if recur:
                return xbmcplugin.addDirectoryItem(handle, ret['url'], li)
            return xbmc.Player().play(ret['url'], li)
        o = urlparse(ret['url'])
        p = o.path.split('/')
        ext = p[-1].split('.')[-1]
        if ext in ('m3u', 'm3u8'):
            if 'header' in ret:
                ret['url'] += '|' + urlencode(ret['header'])
            if recur:
                return xbmcplugin.addDirectoryItem(handle, ret['url'], li)
            return xbmc.Player().play(ret['url'], li)
        if t:
            t = sub1(ret['url'])
    for k, v in ret.items():
        try:
            ret[k] = v.encode('utf-8')
        except:
            pass
    xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urlencode(ret), li, t)


def sub1(url):
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    l = len(p)
    if re.match(r'sports\.localau\.com|www\.itiyu.*\.tv|www\.tiyu.*\.tv', o.netloc):
        if l > 1 and p[1] == 'play':
            return False
        if p[-1] in ('play.html', 'qplay.html'):
            return False
    if re.match(r'www\.localmv.*\.com|www\.localmv.*\.tv|www\.iyingshi.*\.com|www\.iyingshi.*\.tv', o.netloc):
        if l > 1 and p[1] == 'play':
            return False
    if o.netloc == 'api.localau.vip':
        return False
    return True


def sub2(url):
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    l = len(p)
    if re.match(r'sports\.localau\.com|www\.itiyu.*\.tv|www\.tiyu.*\.tv', o.netloc):
        if l > 1 and p[1] == 'game':
            return resp(localau.game(url))
        if l > 1 and p[1] == 'play':
            return resp(localau.sport(url))
        if p[-1] == 'play.html':
            # http://www.itiyu.tv/play.html?id=cctv1
            return resp(localau.tv1(url))
        if p[-1] == 'qplay.html':
            # http://www.itiyu.tv/qplay.html?id=cctv1&hd=13
            return resp(localau.tv2(url))
    if re.match(r'www\.localmv.*\.com|www\.localmv.*\.tv|www\.iyingshi.*\.com|www\.iyingshi.*\.tv', o.netloc):
        if l > 1 and p[1] == 'video':
            return resp(localau.video(url))
        if l > 1 and p[1] == 'play':
            return resp(localau.play(url))
        if l > 1 and p[1] == 'tv':
            return resp(localau.tv0(url))
    if o.netloc == 'api.localau.vip':
        return resp(localau.vip(url))
    return resp({'code': 'localau 020', 'error': url})


def sub3(content):
    try:
        data = json.loads(content)
    except Exception as e:
        return resp({'code': 'localau 030', 'error': str(e)})
    resp(data)


def category(cat):
    if 'page' in q:
        page = int(q['page'][0])
    else:
        page = 1
    resp(localau.category(cat, page))


def sports():
    return resp(localau.sports())


def tv():
    return resp(localau.tv())


def search(s):
    if not s:
        kb = xbmc.Keyboard(heading='Search')
        kb.doModal()
        if not kb.isConfirmed():
            return
        s = kb.getText()
    resp(localau.search(s))


def get_node(url):
    try:
        content = urlopen(url).read().decode('utf-8')
    except:
        content = json.dumps([])
    sub3(content)


handle = int(sys.argv[1])
url = sys.argv[2]
if not url:
    resp({'title': '电影', 'category': 'dianying'})
    resp({'title': '电视剧', 'category': 'dianshiju'})
    resp({'title': '综艺', 'category': 'zongyi'})
    resp({'title': '动漫', 'category': 'dongman'})
    resp({'title': '纪录片', 'category': 'document'})
    resp({'title': '体育直播', 'sports': True})
    resp({'title': '电视直播', 'tv': True})
    resp({'title': 'Search', 'search': ''})
    get_node('http://ims.tian-le.com/localau.json')
else:
    o = urlparse(url)
    q = parse_qs(o.query, True)
    if 'json' in q:
        sub3(q['json'][0])
    elif 'url' in q:
        sub2(q['url'][0])
    elif 'category' in q:
        category(q['category'][0])
    elif 'sports' in q:
        sports()
    elif 'tv' in q:
        tv()
    elif 'search' in q:
        search(q['search'][0])
